<template>
  <client-only>
    <div class="module module-slider-image mobile-fullwidth" :class="{ 'pb-0': data.removePaddingBottom }">
      <div class="row">
        <div class="col-12 col-lg-10 offset-lg-1">
          <atom-slider
            ref="flickity"
            class="main-carousel flickity"
            :options="flickityOptions"
          >
            <div
              v-for="(slide, index) in data.slides"
              :key="index"
              class="carousel-cell slide"
            >
              <atom-image
                class="slider-image"
                :image="slide.image"
                :ratio="getRatio"
                :lazyload="false"
                sizes="(min-width: 768px) and (max-width: 1024px) 95vw, (min-width: 1440px) 448px, 100vw"
              />
              <div class="row">
                <div class="col-12 col-md-6 col-lg-5">
                  <div class="caption-wrapper">
                    <p class="slider-caption">
                      {{ index }}: {{ slide.caption }}
                    </p>
                  </div>
                </div>
              </div>
            </div>
          </atom-slider>
          <div v-if="isMobile" class="flickity-mobile-controls">
            <button
              class="flickity-button flickity-prev-next-button previous"
              type="button" aria-label="Previous"
              @click="$refs.flickity.previous()"
            >
              <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 48 23" style="enable-background:new 0 0 48 23" xml:space="preserve">
                <path d="m35.6 0-2 2 8.3 8.3H-1v2.8h42.5L33.6 21l2 2L47 11.5z"/>
              </svg>
            </button>
            <ol class="flickity-page-dots">
              <li
                v-for="(slide, index) in data.slides"
                :key="index"
                class="dot"
                :class="{ 'is-selected': selectedSlide === index }"
                @click="$refs.flickity.select(index)"
              ></li>
            </ol>
            <button
              class="flickity-button flickity-prev-next-button next"
              type="button" aria-label="Next"
              @click="$refs.flickity.next()"
            >
              <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 48 23" style="enable-background:new 0 0 48 23" xml:space="preserve">
                <path d="m35.6 0-2 2 8.3 8.3H-1v2.8h42.5L33.6 21l2 2L47 11.5z"/>
              </svg>
            </button>
          </div>
          <button
            v-if="isDesktop"
            class="flickity-button flickity-prev-next-button flickity-prev-next-button-desktop previous"
            type="button" aria-label="Previous"
            @click="$refs.flickity.previous()"
          >
            <svg class="flickity-button-icon" viewBox="0 0 100 100">
              <path d="M79.6 8.8 70.4 0l-50 50 50 50 9.2-8.8L38.3 50z" class="arrow"></path>
            </svg>
          </button>
          <button
            v-if="isDesktop"
            class="flickity-button flickity-prev-next-button flickity-prev-next-button-desktop next"
            type="button" aria-label="Next"
            @click="$refs.flickity.next()"
          >
            <svg class="flickity-button-icon" viewBox="0 0 100 100">
              <path d="M79.6 8.8 70.4 0l-50 50 50 50 9.2-8.8L38.3 50z" class="arrow" transform="translate(100, 100) rotate(180) "></path>
            </svg>
          </button>
        </div>
      </div>
    </div>
  </client-only>
</template>

<script>
export default {
  props: {
    data: {
      type:Object,
      default: () => {},
    }
  },
  data() {
    return {
      selectedSlide: 0,
      flickityOptions: {
          wrapAround: true,
          cellAlign: 'left',
          autoPlay: false,
          contain: true,
          selectedAttraction: 0.025,
          friction: 0.3,
          pageDots: false,
          prevNextButtons: false,
          arrowShape: 'M79.6 8.8 70.4 0l-50 50 50 50 9.2-8.8L38.3 50z',
          // any options from Flickity can be used
      },
    };
  },
  computed: {
    getRatio() {
      return '16x9';
    },
    isMobile() {
      return this.$mq === 'sm' || this.$mq === 'xs' || this.$mq === 'md';
    },
    isDesktop() {
      return this.$mq !== 'sm' && this.$mq !== 'xs' && this.$mq !== 'md';
    },
  },
  mounted() {
    this.$nextTick(() => {
      this.$nextTick(() => {
        this.$refs.flickity.on('change', (index) => {
          this.selectedSlide = index;
        });
      });
    });
  },
};
</script>

<style lang="scss">
.module-slider-image {
  // .flickity-page-dots {
  //   padding: 0;
  //   bottom: auto;
  //   top: 0;
  //   margin-top: calc(56.25% - 2rem);

  //   @include media-breakpoint-up(md) {
  //     display: block;
  //   }

  //   .dot {
  //     background-color: $white;
  //     &.is-selected {
  //       background-color: $red;
  //     }
  //   }
  // }

  .caption-wrapper {
    padding: 1rem 1rem 0;

    @include media-breakpoint-up(md) {
      padding: 1rem 0 0;
    }
  }

  .slide {
    &.is-selected {
      .slider-caption {
        opacity: 1;
        transition: opacity ease 0.35s 0.6s;
      }
    }
  }

  .slider-caption {
    font-size: 1rem;
    line-height: 1.25em;
    font-weight: 300;
    opacity: 0;
    transition: opacity ease 0.35s;
  }

  .flickity-mobile-controls {
    padding-bottom: 0;
  }

  .flickity-mobile-controls {
    @include media-breakpoint-up(md) {
      display: flex;
    }
    @include media-breakpoint-up(lg) {
      display: none;
    }
  }

  .flickity-page-dots {
    display: block;
  }

  .flickity-prev-next-button-desktop {
    display: block;
    color: $white;
    top: 0;
    margin-top: calc(28.125% - 1.5rem);
    transform: none;

    @include media-breakpoint-up(md) {
      display: none;
    }

    @include media-breakpoint-up(lg) {
      display: block;
      width: 3rem;
      height: 3rem;
      padding: 0;
      color: $black;
      border-radius: 0;
      background-color: transparent;

      &:hover {
        background: transparent;
      }

      &.next {
        right: -10.5%;

        @include media-breakpoint-up(xl) {
          right: -100px;
        }
      }

      &.previous {
        left: -10.5%;

        @include media-breakpoint-up(xl) {
          left: -100px;
        }
      }
    }
  }
}
</style>
